
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>WebWork2源码分析 / iVAN</title>

    <meta name="description" content="WebWork2源码分析 web Author: zhuam   昨晚一口气看完了夏昕写的&lt;&lt;Webwork2_Guide&gt;&gt;,虽然文档资料很简洁,但仍不失为一本好的WebWork2书籍,看的出作者的经验和能力都是非常的老道,在此向作者的开源精神致敬,并在此引用夏昕的那句话So many open source projects, Why not Open your Documents?   今天下载了最新的WebWork2版本, 开始了源码分析,这份文档只能算是我的个人笔记,也没时间细细校对,且 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">WebWork2源码分析</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>web</p>
<p>Author: zhuam</p>
<p> </p>
<p>昨晚一口气看完了夏昕写的&lt;&lt;Webwork2_Guide&gt;&gt;,虽然文档资料很简洁,但仍不失为一本好的WebWork2书籍,看的出作者的经验和能力都是非常的老道,在此向作者的开源精神致敬,并在此引用夏昕的那句话So many open source projects, Why not Open your Documents?</p>
<p> </p>
<p>今天下载了最新的WebWork2版本, 开始了源码分析,这份文档只能算是我的个人笔记,也没时间细细校对,且个人能力有限,难免有许多分析错误或笔误的地方,还望各位指正.</p>
<p> </p>
<p>WebWork1.x版本是采用紧偶合的架构,类似如Struts ,而WebWork2.x版本后采用了新的架构 WebWork2.x+XWork1.x 就是因为他采用了这样架构所以才吸引我去看他源码的啊!新的架构分离了与Servlet API的紧偶合,这样我们的系统结构将更加的清晰,且系统测试与系统移植将来的更加方便,其实WebWork1.x版本我也没有看过,所谓的紧偶合也是看网上是这么说的,没有发言权啊,呵呵!</p>
<p>在新的架构中WebWork2.x的作用是负责将用户的HTTP请求分离出来,使的请求完全的脱离Servlet API,然后将这些请求用Map的方式传入XWork1.x,且XWork1.x通过Interceptor 将Map 中的数据传到我们的VO中,然后由对应的自定义Action来调用.</p>
<p> </p>
<p>下面首先来看WebWork2.x怎么分离HTTP请求,其实他是通过ServletDispatcher来达到目的.代码如下所示:</p>
<p>public static HashMap createContextMap(Map requestMap, Map parameterMap, Map sessionMap, Map applicationMap, HttpServletRequest request, HttpServletResponse response, ServletConfig servletConfig) {</p>
<p>        HashMap extraContext = new HashMap();</p>
<p>//存放HTTP中上传文件的request  session请求</p>
<p>        extraContext.put(ActionContext.PARAMETERS, parameterMap);</p>
<p>        extraContext.put(ActionContext.SESSION, sessionMap);</p>
<p>        extraContext.put(ActionContext.APPLICATION, applicationMap);</p>
<p>        extraContext.put(ActionContext.LOCALE, (locale == null) ? request.getLocale() : locale);</p>
<p>        extraContext.put(HTTP_REQUEST, request);</p>
<p>        extraContext.put(HTTP_RESPONSE, response);</p>
<p>        extraContext.put(SERVLET_CONFIG, servletConfig);</p>
<p>        extraContext.put(ComponentInterceptor.COMPONENT_MANAGER, request.getAttribute(ComponentManager.COMPONENT_MANAGER_KEY));</p>
<p>        // helpers to get access to request/session/application scope</p>
<p>//这里用于存放HTTP中的request  session请求</p>
<p>        extraContext.put("request", requestMap);</p>
<p>        extraContext.put("session", sessionMap);</p>
<p>        extraContext.put("application", applicationMap); </p>
<p>        extraContext.put("parameters", parameterMap);</p>
<p>        AttributeMap attrMap = new AttributeMap(extraContext);</p>
<p>        extraContext.put("attr", attrMap);</p>
<p>        return extraContext;</p>
<p>    } </p>
<p>以上的是ServletDispatcher 中的方法createContextMap是用于将HTTP请求封装到Map中去,且ServletDispatcher也是WebWork2.x的控制器,负责分离出Action, 他是通过service方法去调用serviceAction方法,然后由serviceAction来完成操作的,代码如下:</p>
<p> </p>
<p>public void serviceAction(HttpServletRequest request, HttpServletResponse response, String namespace, String actionName, Map requestMap, Map parameterMap, Map sessionMap, Map applicationMap) {</p>
<p>        HashMap extraContext = createContextMap(requestMap, parameterMap, sessionMap, applicationMap, request, response, getServletConfig());  //实例化Map请求</p>
<p>        extraContext.put(SERVLET_DISPATCHER, this);</p>
<p>        // If there was a previous value stack, then create a new copy and pass it in to be used by the new Action</p>
<p>        OgnlValueStack stack = (OgnlValueStack) request.getAttribute(ServletActionContext.WEBWORK_VALUESTACK_KEY);</p>
<p>        if (stack != null) {</p>
<p>            extraContext.put(ActionContext.VALUE_STACK,new OgnlValueStack(stack));</p>
<p>        }</p>
<p>        try {</p>
<p>            ActionProxy proxy = ActionProxyFactory.getFactory().createActionProxy(namespace, actionName, extraContext);</p>
<p>//这里actionName是通过两道getActionName解析出来的,下面是ServletDispatcher的 TODO: QUESTIONS转载出来让大家看一看</p>
<p> * 1) What unit is maxSize of attachments in? (assuming bytes for now)</p>
<p> * 2) Isn't error message wrong in catch of try/catch in service() method?</p>
<p> * 3) Why is getActionName(String) not declared public? (The fix would not be an API addition so this could be ( done for pre 2.1)</p>
<p> * 4) Why does createContextMap(...) return a HashMap and not a Map? (2.1 api change)</p>
<p> * 5) Why doesn't getNameSpace(request) get the servlet path in the same way that getActionName(request) does?</p>
<p> * 6) Why does getParameterMap throw an IOException? Can't see a reason for that. (2.1 api change)</p>
<p> */</p>
<p>            request.setAttribute(ServletActionContext.WEBWORK_VALUESTACK_KEY, proxy.getInvocation().getStack());</p>
<p>            proxy.execute();</p>
<p>            // If there was a previous value stack then set it back onto the request</p>
<p>            if (stack != null){</p>
<p>                request.setAttribute(ServletActionContext.WEBWORK_VALUESTACK_KEY,stack);</p>
<p>            }</p>
<p>        } catch (ConfigurationException e) {</p>
<p>            log.error("Could not find action", e);</p>
<p>            sendError(request, response, HttpServletResponse.SC_NOT_FOUND, e);</p>
<p>        } catch (Exception e) {</p>
<p>            log.error("Could not execute action", e);</p>
<p>            sendError(request, response, HttpServletResponse.SC_INTERNAL_SERVER_ERROR, e);</p>
<p>        }</p>
<p>}</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 08:01:29</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/request/" title="request">request</a>, <a href="https://www.iamivan.net/tag/response/" title="response">response</a>, <a href="https://www.iamivan.net/tag/map/" title="Map">Map</a>, <a href="https://www.iamivan.net/tag/put/" title="put">put</a>, <a href="https://www.iamivan.net/tag/put%e8%af%b7%e6%b1%82/" title="put请求">put请求</a>, <a href="https://www.iamivan.net/tag/put%e8%af%b7%e6%b1%82%e4%bd%bf%e7%94%a8/" title="put请求使用">put请求使用</a>, <a href="https://www.iamivan.net/tag/webwork/" title="webwork">webwork</a>, <a href="https://www.iamivan.net/tag/requestmapping/" title="requestmapping">requestmapping</a>, <a href="https://www.iamivan.net/tag/ognlvaluestack/" title="ognlvaluestack">ognlvaluestack</a>, <a href="https://www.iamivan.net/tag/actioncontext/" title="ActionContext">ActionContext</a>, <a href="https://www.iamivan.net/tag/webwork%e4%b8%8b%e8%bd%bd/" title="webwork下载">webwork下载</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>WebWork2源码分析的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/aM1X1jb.html" rel="bookmark">WebWork2源码分析续二</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				web 下面我们再来分析另一个拦截器的实现ModelDrivenInterceptor,首先说说他的设计目的,我们知道在Struts中通常有一个ActionFormBean他是用来封装请求数据的,在WebWork2.x中这一功能得到了进一步的发挥,他可以实现两中Action驱动模式,他们都是信息携带者. Property-Driven Model-Driven   最通俗的解释就是, Property-Driven通过属性来贯穿整个MVC,而Model-Driven就是通过Model对象来贯穿整			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/wzVREmz.html" rel="bookmark">WebWork2源码分析续三</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				web 最后我打算分析一下WebWork2.x中的输入校检部分,校检数据通常包括客户端检查和服务端检查两种,在WebWork2.x中都有很好的支持,首先来分析服务端,服务端的校检类全部来自于com.opensymphony.xwork.validator包,服务端的所有校检工作都是通过一个ValidationInterceptor拦截器来进行拦截的,所以说Interceptor在WebWork2.x中的地位就相当于我们心中的&quot;神&quot;,他是用来拯救一切的,有点夸张了,哈哈! 下面请欣赏Va			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/qbaeQgb.html" rel="bookmark">WebWork2源码分析续一</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				web 至于Action是的创建则是由ActionProxy来完成的,来看一段简要的程序调用 ActionProxy proxy = ActionProxyFactory.getFactory().createActionProxy(namespace, actionName, extraContext); request.setAttribute(ServletActionContext.WEBWORK_VALUESTACK_KEY, proxy.getInvocation().getStac			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/OM9Q0gM.html" rel="bookmark">JUnir源码分析（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.引子 JUnit源码是我仔细阅读过的第一个开源项目源码.阅读高手写的代码能学到一些好的编程风格和实现思路,这是提高自己编程水平行之有效的方法,因此早就想看看这些赫赫有名的框架是怎么回事了.今天就拿最简单的JUnit下手,也算开始自己的源码分析之路.   JUnit作为最著名的单元测试框架,由两位业界有名人士协力完成,已经经历了多次版本升级(了解JUnit基础.JUnit实践).JUnit总体来说短小而精悍,有不少值得我们借鉴的经验在里面:但是也有一些不足存在,当然这对于任何程序来说都是难免的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ybjA2Zz.html" rel="bookmark">java io学习（三） 管道的简介&comma;源码分析和示例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				管道(PipedOutputStream和PipedInputStream)的简介,源码分析和示例 本章,我们对java 管道进行学习. java 管道介绍 在java中,PipedOutputStream和PipedInputStream分别是管道输出流和管道输入流. 它们的作用是让多线程可以通过管道进行线程间的通讯.在使用管道通信时,必须将PipedOutputStream和PipedInputStream配套使用. 使用管道通信时,大致的流程是:我们在线程A中向PipedOutputStr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/rz48W1z.html" rel="bookmark">java io学习（二）ByteArrayOutputStream的简介&comma;源码分析和示例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ByteArrayOutputStream的简介,源码分析和示例(包括OutputStream) 前面学习ByteArrayInputStream,了解了&quot;输入流&quot;.接下来,我们学习与ByteArrayInputStream相对应的输出流,即ByteArrayOutputStream. 本章,我们会先对ByteArrayOutputStream进行介绍,在了解了它的源码之后,再通过示例来掌握如何使用它. ByteArrayOutputStream 介绍 ByteArrayOutputS			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/5zOZX5p.html" rel="bookmark">java io学习（一）ByteArrayInputStream的简介&comma;源码分析和示例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ByteArrayInputStream的简介,源码分析和示例(包括InputStream) 我们以ByteArrayInputStream,拉开对字节类型的&quot;输入流&quot;的学习序幕. 本章,我们会先对ByteArrayInputStream进行介绍,然后深入了解一下它的源码,最后通过示例来掌握它的用法. ByteArrayInputStream 介绍 ByteArrayInputStream 是字节数组输入流.它继承于InputStream. 它包含一个内部缓冲区,该缓冲区包含从流中读取			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXBPAvb.html" rel="bookmark">mahout源码分析之DistributedLanczosSolver（七） 总结篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Mahout版本:0.7,hadoop版本:1.0.4,jdk:1.7.0_25 64bit. 看svd算法官网上面使用的是亚马逊的云平台计算的,不过给出了svd算法的调用方式,当算出了eigenVectors后,应该怎么做呢?比如原始数据是600*60(600行,60列)的数据,计算得到的eigenVectors是24*60(其中的24是不大于rank的一个值),那么最后得到的结果应该是original_data乘以eigenVectors的转置这样就会得到一个600*24的矩阵,这样就达到了			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M91kBVM.html" rel="bookmark">mahout源码分析之DistributedLanczosSolver（五）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Mahout版本:0.7,hadoop版本:1.0.4,jdk:1.7.0_25 64bit. 1. Job 篇 接上篇,分析到EigenVerificationJob的run方法: public int run(Path corpusInput, Path eigenInput, Path output, Path tempOut, double maxError, double minEigenValue, boolean inMemory, Configuration conf) thro			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qbaZxQM.html" rel="bookmark" class="title">jsp中的数据库编程</a>
					<div>
						js|编程|数据|数据库 一,SQL复习1,SQL语句分为两类:DDL(Data Definition Language)和DML(Dat Manipulation Languge,数据操作语言).前 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpn5KjM.html" rel="bookmark" class="title">俞军：百度更加懂得网民</a>
					<div>
						    2008奥委会推出的迎奥运动员口号是&quot;我参与我奉献我快乐&quot;.而在百度董事长兼首席执行官李彦宏看来,这个口号显然也是对正在日益流行的&quot;知识达人&quot;的最好诠释 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMlekYp.html" rel="bookmark" class="title">论坛增加外链内中秘密你知道多少</a>
					<div>
						网站优化离不开添加外链的工作,凭心而论,外链的工作远比写原创文章还要乏味.困难.枯燥,因为你既要考虑添加外链网站的PR值,又要考虑这个网站是否允许你添加外链,甚至你是否拥有这些外链资源.因此,对于新手 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1Mvgv1p.html" rel="bookmark" class="title">ASP&period;NET Authentication Provider</a>
					<div>
						asp.net ASP.NET 提供了一些新型的Authentication 和 Authorization 方案,对于开发人员来说这将是和以前不同的一种方式.可喜的是ASP.NET提供的方案多样更加 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvwL5p.html" rel="bookmark" class="title">TP-Link 150M 迷你型无线路由器</a>
					<div>
						前面 gOxiA 入手了一台8口千兆交换,主要用于外出搭建临时的高速数据交换网,这次又入手了一台 TP-Link 150M 迷你型无线路由器,型号是 TL-WR700N!这款迷你无线路由器非常的小巧, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnY7ZrM.html" rel="bookmark" class="title">将文字图片转成word文档的方法</a>
					<div>
						  我们在日常工作,有时候会遇到需要把文字图片或者扫描的文件变成word文档,最笨的方法就是一个一个字的打到word文档,有一些图片的文字是可以在搜索引擎上找到的,但是首先这个需要运气好.不过,现在小 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MywGyPz.html" rel="bookmark" class="title">电源管理中的电源使用方案选项为灰色的解决方案</a>
					<div>
						  故障现象: Microsoft Windows xp 的计算机中打开了控制面板中的&quot;电源选项&quot;.但是,显示在&quot;电源使用方案&quot;选项卡中的电源使用方案选项不可使 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq89VYb.html" rel="bookmark" class="title">当当网傅强谈双十一：胜利都是留给有准备的人</a>
					<div>
						今年伴随着双十一的大促销,互联网出现了非常疯狂的采购狂潮.采购狂潮不仅为天猫.淘宝.当当等电商巨头带来了巨额利润,也对这些电子商务网站的技术架构提出了严峻的挑战.本次我们采访到了当当网技术部高级总监傅 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmG5Xqb.html" rel="bookmark" class="title">说说jsonp</a>
					<div>
						什么是jsonp jsonp充其量只能说是一种&quot;方法&quot;.它可以让页面从其他域中获取资料.   首先要知道的是同源策略,在javascript中使用http请求(ajax)是会受到同 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr3Rdjp.html" rel="bookmark" class="title">link环境下制作一款《订餐软件》，其中不同冷盘的联系怎么实现？</a>
					<div>
						问题描述 link环境下制作一款&lt;订餐软件&gt;,其中不同冷盘的联系怎么实现? link环境下制作一款&lt;订餐软件&gt;,其中不同冷盘的联系怎么实现? 解决方案 所谓联系,就是你在你的数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDYravb.html" rel="bookmark" class="title">PHP分页类集锦&lowbar;php实例</a>
					<div>
						分页类一 复制代码 代码如下: &lt;?php /** 分页类 修改:Silence Creatdate:2006-5-30 LastModify:2009-5-31 使用方法 $page = ne ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjQvdmz.html" rel="bookmark" class="title">让Yahoo&lpar;雅虎&rpar;1G邮箱POP的配置方法</a>
					<div>
						现在Yahoo的邮箱有1G的空间,但是他只提供Web收发方式,国内的网络状况大家都很清楚,这简直是折磨.即便是Yahoo退出了雅虎通,但仍然是WebModel,没办法.不过还好,现在Yahoo也可以P ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVkjBb.html" rel="bookmark" class="title">新东方泡泡出儿童读物下一步动漫衍生品？</a>
					<div>
						新东方集团副总裁汪海涛今日透露,泡泡少儿和国内一家儿童图书公司合作,以泡泡为主人翁的系列儿童故事绘本将陆续上市.新东方旗下定位少儿群体的品牌泡泡逐渐被具象化,图书音像的下一步会不会是动漫.玩偶等衍生品 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPr11p.html" rel="bookmark" class="title">关于代码审查的几点建议</a>
					<div>
						关于代码审查的几点建议 Code Review即代码审查是软件开发中常用的手段,它和QA测试相比,更容易发现架构以及时序相关等较难发现的问题,还可以帮助团队成员统一编程风格,提高编程技能等.代码审查被 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWxlvp.html" rel="bookmark" class="title">关于从数据库取下来菜单，以及取到之后如何替换真实的值</a>
					<div>
						问题描述 下拉菜单是指标,指标是从多个数据库的字段取来的,显示的中文名,这时候指标还没有真实的数值.请问如何存储才能在后面那些数据库中有真实的值之后作出替换.比如:下拉菜单中有指标1指标2指标3.我用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOm3o9M.html" rel="bookmark" class="title">不重启不当机！Linux内核热补丁的四种技术</a>
					<div>
						不重启不当机!Linux内核热补丁的四种技术 供图: Shutterstock 有多种技术在竞争成为实现Linux内核热补丁的最优方案. 没人喜欢重启机器,尤其是涉及到一个内核问题的最新补丁程序. 为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba7owNp.html" rel="bookmark" class="title">hibernate spring-hibernate hbm2ddl自动生成表时如何生成父类的属性</a>
					<div>
						问题描述 hibernate hbm2ddl自动生成表时如何生成父类的属性 子类Master 父类BaseVo 属性 /**创建时间/ public Date TCreateTime; /**创建人/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDe0JLb.html" rel="bookmark" class="title">dom-手机浏览器实际上是把网页放大了？</a>
					<div>
						问题描述 手机浏览器实际上是把网页放大了? 一个div,设置宽度是20px,在电脑上,就是用20px来显示 在手机浏览器上,实际上,不止占用20px? 解决方案 head增加这个标签 &lt;meta ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvm3y6b.html" rel="bookmark" class="title">请教高手，小问题</a>
					<div>
						问题描述 我想用serialPort控件发送和接受字符串.下面是我写的代码,但是好像错了privatevoidForm1_Load(objectsender,EventArgse){serialPor ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZXy6z.html" rel="bookmark" class="title">如何在 CentOS 7 上安装和安全配置 MariaDB 10</a>
					<div>
						MariaDB 是 MySQL 数据库的自由开源分支,与 MySQL 在设计思想上同出一源,在未来仍将是自由且开源的. 在这篇博文中,我将会介绍如何在当前使用最广的 RHEL/CentOS 和 Fed ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeROONb.html" rel="bookmark" class="title">数据库连接-在与 SQL Server 建立连接时出现与网络相关的或特定于实例的错误</a>
					<div>
						问题描述 在与 SQL Server 建立连接时出现与网络相关的或特定于实例的错误 在与 SQL Server 建立连接时出现与网络相关的或特定于实例的错误.未找到或无法访问服务器.请验证实例名称是否 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGEkXlM.html" rel="bookmark" class="title">中小网站们的&OpenCurlyDoubleQuote;非奥运战略&rdquo;</a>
					<div>
						中介交易 SEO诊断淘宝客 站长团购 云主机 技术大厅 2008年快过去一个月了,该说点平时不敢说的,该来点劲爆的话题了.从07年底就一直在酝酿一个关于中小网站的&quot;非奥运战略&quot;的概 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGZAWkp.html" rel="bookmark" class="title">java执行shell命令-Java执行shell命令问题</a>
					<div>
						问题描述 Java执行shell命令问题 我在java代码中执行shell命令改变Android目录下的文件123.sh的权限, 使用Runtime.getRuntime().exec(&quot;c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOJJP8p.html" rel="bookmark" class="title">RSA总裁RSA 2016上揭示安全行业五大方向</a>
					<div>
						每一年RSA上,RSA总裁的主题演讲都能准确把握安全行业的发展方向和主题,成为全球安全行业的方向标. 美国当地时间3月1日,RSA总裁Amit Yoran发表了题为&quot;睡者醒来&quot;的主 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M60Egoz.html" rel="bookmark" class="title">试试SQLSERVER2014的内存优化表</a>
					<div>
						原文:试试SQLSERVER2014的内存优化表 试试SQLSERVER2014的内存优化表 SQL Server 2014中的内存引擎(代号为Hekaton)将OLTP提升到了新的高度. 现在,存储 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0nlOPz.html" rel="bookmark" class="title">数字解密如何解决</a>
					<div>
						问题描述 score=061720244323920%7C224%2C208%2C28%2C%7Cef82f57dfc53cfa0715ba68d44ea2120%7C638abff964addd2b ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvnLJ5M.html" rel="bookmark" class="title">乔布斯：1997年就看好云计算</a>
					<div>
						&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp; 9月22日消息,据国外媒体报道,从来没人怀疑过乔布斯的眼界 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5RaE7z.html" rel="bookmark" class="title">关于微信浏览器的cookie问题</a>
					<div>
						问题描述 关于微信浏览器的cookie问题 微信浏览器cookie被刷新,导致无法区分登陆状态.需要怎样做才能保持登陆状态 解决方案 可以根据微信用户openid 来区分,但是需要服务号有oatoh2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7lQ2z.html" rel="bookmark" class="title">玩转 Varnish 缓存代理</a>
					<div>
						Varnish 是互联网架构中重要的缓存代理组件.Varnish 一般跑在流量入口处,作为最前端一道防御,非常重要. 虽然 Varnish 并不像 Nginx 那么流行.Varnish 就像 Ngin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx0nlQM.html" rel="bookmark" class="title">新华三下一代计算开启新格局</a>
					<div>
						数字经济已融入到人们工作与生活的每个角落.在数字经济浪潮席卷全球的今天,面对数字化转型趋势下业务需求的复杂性,企业需要更灵活.更动态.随需应变的IT基础设施,其中服务器产品的核心支撑作用首当其冲. 前 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
